searchData={"items":[{"type":"module","title":"CloudfrontSigner","doc":"Elixir implementation of cloudfront's signed url algorithm.  Basic usage is:\n\n```\nCloudfrontSigner.Distribution.from_config(:scope, :key)\n|> CloudfrontSigner.sign(\"some/path\", [arg: \"val\"], some_expiry)\n```","ref":"CloudfrontSigner.html"},{"type":"function","title":"CloudfrontSigner.sign/4","doc":"Signs a url for the given `Distribution.t` struct constructed from the `path` and `query_params` provided.  `expiry`\nis in seconds.","ref":"CloudfrontSigner.html#sign/4"},{"type":"module","title":"CloudfrontSigner.Application","doc":"This module is the entry point for the CloudfrontSigner application.","ref":"CloudfrontSigner.Application.html"},{"type":"function","title":"CloudfrontSigner.Application.start/2","doc":"","ref":"CloudfrontSigner.Application.html#start/2"},{"type":"module","title":"CloudfrontSigner.Distribution","doc":"Representation of a cloudfront distribution for the purpose of computing a signed url.\nWe need the address of the distribution and the private key for RSA signature generation","ref":"CloudfrontSigner.Distribution.html"},{"type":"function","title":"CloudfrontSigner.Distribution.from_config/2","doc":"Creates a `Distribution.t` record from the contents of `Application.get_env(app, scope)`","ref":"CloudfrontSigner.Distribution.html#from_config/2"},{"type":"function","title":"CloudfrontSigner.Distribution.from_map/1","doc":"","ref":"CloudfrontSigner.Distribution.html#from_map/1"},{"type":"type","title":"CloudfrontSigner.Distribution.t/0","doc":"","ref":"CloudfrontSigner.Distribution.html#t:t/0"},{"type":"module","title":"CloudfrontSigner.DistributionRegistry","doc":"Agent to store and fetch cloudfront distributions, to avoid expensive runtime pem decodes","ref":"CloudfrontSigner.DistributionRegistry.html"},{"type":"function","title":"CloudfrontSigner.DistributionRegistry.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"CloudfrontSigner.DistributionRegistry.html#child_spec/1"},{"type":"function","title":"CloudfrontSigner.DistributionRegistry.get_distribution/2","doc":"","ref":"CloudfrontSigner.DistributionRegistry.html#get_distribution/2"},{"type":"function","title":"CloudfrontSigner.DistributionRegistry.start_link/1","doc":"","ref":"CloudfrontSigner.DistributionRegistry.html#start_link/1"},{"type":"module","title":"CloudfrontSigner.Policy","doc":"Defines a cloudfront signature policy, and a string coercion method for it","ref":"CloudfrontSigner.Policy.html"},{"type":"function","title":"CloudfrontSigner.Policy.generate_signature_and_policy/2","doc":"","ref":"CloudfrontSigner.Policy.html#generate_signature_and_policy/2"},{"type":"type","title":"CloudfrontSigner.Policy.t/0","doc":"","ref":"CloudfrontSigner.Policy.html#t:t/0"},{"type":"extras","title":"Readme","doc":"# CloudfrontSigner\n\nElixir implementation of Cloudfront's url signature algorithm. Supports expiration policies and\nruntime configurable distributions. Fork of https://github.com/Frameio/cloudfront-signer","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"The patched package can be installed\nby adding `cloudfront_signer` to your list of dependencies in `mix.exs` as a git based dependency:\n\n```elixir\ndef deps do\n  [\n    {:cloudfront_signer,\n       git: \"https://github.com/podium/cloudfront-signer.git\",\n       ref: \"73b53cf1364d92708f43ca60dc7150a61cfa5191\"}\n  ]\nend\n```\n\nConsult the [mix documentation for git based dependencies](https://hexdocs.pm/mix/1.16.0/Mix.Tasks.Deps.html) for valid syntax options.\n\nConfigure a distribution with:\n\n```elixir\nconfig :my_app, :my_distribution,\n  domain: \"https://some.cloudfront.domain\",\n  private_key: {:system, \"ENV_VAR\"}, # or {:file, \"/path/to/key\"}\n  key_pair_id: {:system, \"OTHER_ENV_VAR\"}\n```\n\nThen simply do:\n\n```elixir\nCloudfrontSigner.Distribution.from_config(:my_app, :my_distribution)\n|> CloudfrontSigner.sign(path, [arg: \"value\"], expiry_in_seconds)\n```\n\nIf you want to cache pem decodes (which is a wise choice), a registry of decoded distributions is available. Simply do:\n\n```elixir\nCloudfrontSigner.DistributionRegistry.get_distribution(:my_app, :my_distribution)\n|> CloudfrontSigner.sign(path, [arg: \"value], expiry)\n```","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)\n\n## [Unreleased]","ref":"changelog.html"},{"type":"extras","title":"0.2.0 - 2025-01-28 - Changelog","doc":"","ref":"changelog.html#0-2-0-2025-01-28"},{"type":"extras","title":"🚀 Features - Changelog","doc":"- Swap Poison for Jason.","ref":"changelog.html#features"},{"type":"extras","title":"🐛 Bug Fixes - Changelog","doc":"- @spec should match function guards\n- Optional argument as last arg","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"🚜 Refactor - Changelog","doc":"- Refactor to custom policy","ref":"changelog.html#refactor"},{"type":"extras","title":"📚 Documentation - Changelog","doc":"- Add docs\n- Syntax fix","ref":"changelog.html#documentation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}